<script>
import * as timeago from 'timeago.js'
import { GlLabel, GlIcon, GlSprintf } from '@gitlab/ui'

export default {
  name: 'MdIssue',

  components: { GlLabel, GlIcon, GlSprintf },

  props: {
    issue: {
      type: Object,
      required: true,
    },
  },

  methods: {
    labelTitle(label) {
      return label.title || label.name
    },

    timeAgo(timestamp) {
      return timeago.format(timestamp)
    },
  },
}
</script>

<template>
  <div class="py-4">
    <md-external-link
      :href="issue.webUrl"
      :label="issue.title"
      class="block font-medium text-black"
    />
    <div class="mb-2 inline-flex flex-wrap text-gray-500">
      <span class="mr-1">{{ issue.reference }}</span>
      <span class="mr-1 hidden sm:inline">•</span>
      <span class="mr-2">
        <gl-sprintf message="created %{timeAgo} by %{author}">
          <template #timeAgo>
            <span>{{ timeAgo(issue.createdAt) }}</span>
          </template>
          <template #author>
            <md-external-link
              :href="issue.author.webUrl"
              :label="issue.author.name"
              class="text-gray-700"
            />
          </template>
        </gl-sprintf>
      </span>
      <md-external-link
        v-if="issue.milestone"
        :href="`https://gitlab.com${issue.milestone.webPath}`"
        class="mr-2 inline-flex items-center text-gray-600"
      >
        <gl-icon :size="16" class="mr-1" name="clock" />
        {{ issue.milestone.title }}
      </md-external-link>
      <span v-if="issue.weight !== null" class="mr-2 inline-flex items-center">
        <gl-icon :size="16" class="mr-1" name="weight" />
        {{ issue.weight }}
      </span>
    </div>
    <div v-if="issue.labels.nodes.length" class="flex-inline">
      <gl-label
        v-for="label in issue.labels.nodes"
        :key="label.id"
        class="pointer-events-none mr-2 mb-1"
        :background-color="label.color"
        :title="labelTitle(label)"
        :scoped="labelTitle(label).includes('::')"
      />
    </div>
  </div>
</template>
